{% load static %}
<!doctype html>
<html lang="en">
    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
        <link rel="apple-touch-icon" sizes="180x180" href="/static/img/icon/apple-touch-icon.png">
        <link rel="icon" type="image/png" sizes="32x32" href="/static/img/icon/favicon-32x32.png">
        <link rel="icon" type="image/png" sizes="16x16" href="/static/img/icon/favicon-16x16.png">
        <link rel="manifest" href="/static/img/icon/site.webmanifest">
        <link rel="mask-icon" href="/static/img/icon/safari-pinned-tab.svg" color="#5bbad5">
        <meta name="msapplication-TileColor" content="#da532c">
        <meta name="theme-color" content="#ffffff">

        <!-- CSS -->
        <link href="{% static 'css/corpora.css' %}" rel="stylesheet">
        {% block css %}
        {% endblock %}

        <title>Corpora</title>
    </head>
    <body>

        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="d-flex justify-content-center align-items-center brand">
                        <a href="/"><img src="{% static 'img/logo.png' %}" class="logo" /></a>
                    </div>
                </div>
            </div>
        </div>

        <div class="container mt-4">
            <div class="row">
                <div class="col-3"></div>
                <div class="col-6">
                    {% if response.messages or response.errors %}
                        <div class="container-fluid mt-4">
                            {% if response.messages %}
                                {% for message in response.messages %}
                                    <div class="alert alert-info" role="alert">
                                        {{ message }}
                                    </div>
                                {% endfor %}
                            {% endif %}

                            {% if response.errors %}
                                {% for error in response.errors %}
                                    <div class="alert alert-danger" role="alert">
                                        {{ error }}
                                    </div>
                                {% endfor %}
                            {% endif %}
                        </div>
                    {% endif %}

                    {% if not response.scholar and not register %}
                        <div class="card mb-3">
                            <form method="post">
                                {% csrf_token %}
                                <div class="card-header">
                                    <h4>Login</h4>
                                </div>
                                <div class="card-body">
                                    <div class="form-group">
                                        <label for="username-box">Username</label>
                                        <input type="text" class="form-control" id="username-box" name="username">
                                    </div>
                                    <div class="form-group">
                                        <label for="password-box">Password</label>
                                        <input type="password" class="form-control" id="password-box" name="password">
                                    </div>
                                </div>
                                <div class="card-footer">
                                    <button type="submit" class="btn btn-primary">Login</button> or <a href="/scholar?register=y">register here</a>.
                                </div>
                            </form>
                        </div>
                    {% elif response.scholar or register %}
                        <div class="card mb-3">
                            <form method="post">
                                {% csrf_token %}
                                <div class="card-header">
                                    <h4>{% if register %}Register{% else %}My Account{% endif %}</h4>
                                </div>
                                <div class="card-body">
                                    <div class="form-group">
                                        <label for="username-box">Username</label>
                                        <input type="text" class="form-control" id="username-box" name="username" value="{{ response.scholar.username }}" {% if response.scholar %}readonly{% endif %}>
                                        {% if response.scholar %}
                                            <small class="form-text text-muted">Once created, a username cannot be changed.</small>
                                        {% endif %}
                                    </div>
                                    <div class="form-group">
                                        <label for="password-box">Password</label>
                                        <input type="password" class="form-control" id="password-box" name="password">
                                    </div>
                                    <div class="form-group">
                                        <label for="password-box2">Confirm Password</label>
                                        <input type="password" class="form-control" id="password-box2" name="password2">
                                    </div>
                                    <div class="form-group">
                                        <label for="fname-box">First Name</label>
                                        <input type="text" class="form-control" id="fname-box" name="fname" value="{{ response.scholar.fname }}">
                                    </div>
                                    <div class="form-group">
                                        <label for="lname-box">Last Name</label>
                                        <input type="text" class="form-control" id="lname-box" name="lname" value="{{ response.scholar.lname }}">
                                    </div>
                                    <div class="form-group">
                                        <label for="email-box">Email</label>
                                        <input type="email" class="form-control" id="email-box" name="email" value="{{ response.scholar.email }}">
                                    </div>
                                    {% if response.scholar %}
                                        <div class="form-group">
                                            <label for="token-box">API Token</label>
                                            <input type="text" class="form-control" id="token-box" value="{{ response.scholar.auth_token }}" {% if response.scholar %}readonly{% endif %}>
                                            <small class="form-text text-muted mb-1">
                                                API tokens allow you to access Corpora data from third-party software. Keep it secret! Keep it safe!
                                                If you believe your token is no longer secret, you may generate a new one by clicking the button below.
                                            </small>
                                            <a href="?gen_token=y" class="btn btn-secondary">Generate New Token</a>
                                        </div>
                                        <div class="form-group">
                                            <label for="auth-token-ips-div">API IP Addresses</label>
                                            <small class="form-text text-muted mb-2">
                                                API tokens will only work for non-open access Corpora if API requests originate from the following
                                                IP addresses.
                                            </small>
                                            <div id="auth-token-ips-div">
                                            {% for ip_addr in response.scholar.auth_token_ips %}
                                                <div id="auth-token-ip-div-{{ forloop.counter }}" class="form-group row row-no-gutters">
                                                    <label for="auth-token-ip-{{ forloop.counter }}" class="col-sm-3 col-form-label">IP Address {{ forloop.counter }}</label>
                                                    <div class="col-sm-6">
                                                        <input id="auth-token-ip-{{ forloop.counter }}" type="text" class="form-control" name="auth-token-ip-{{ forloop.counter }}" value="{{ ip_addr }}">
                                                    </div>
                                                    <div class="col-sm-3">
                                                        <button type="button" id="auth-token-ip-{{ forloop.counter }}-remove-button" class="btn btn-danger auth-token-ip-remove-button">Remove</button>
                                                    </div>
                                                </div>
                                            {% endfor %}
                                            </div>
                                            <div class="form-group">
                                                <button type="button" id="auth-token-ip-add-button" class="btn btn-primary">Add IP Address</button>
                                            </div>
                                        </div>
                                    {% endif %}
                                </div>
                                <div class="card-footer">
                                    <button type="submit" class="btn btn-primary mr-1">{% if register %}Register{% else %}Update{% endif %}</button>
                                    {% if response.scholar %}
                                        <a href="?logout=y" class="btn btn-secondary">Logout</a>
                                    {% endif %}
                                </div>
                            </form>
                        </div>
                    {% endif %}
                </div>
                <div class="col-3"></div>
            </div>
        </div>

        <script src="{% static 'js/jquery-3.3.1.min.js' %}"></script>
        <script src="{% static 'js/popper.min.js' %}"></script>
        <script src="{% static 'js/bootstrap.min.js' %}"></script>
        <script src="{% static 'js/corpora.js' %}"></script>
        <script type="application/javascript">
            var auth_token_ip_count = {% if response.scholar.auth_token_ips %}{{ response.scholar.auth_token_ips|length }}{% else %}0{% endif %};
            
            $(document).ready(function() {
                {% if not response.scholar and not register %}
                    $('#username-box').focus();
                {% endif %}

                $('#auth-token-ip-add-button').click(function() {
                    auth_token_ip_count += 1;
                    $('#auth-token-ips-div').append(`
                        <div id="auth-token-ip-div-${auth_token_ip_count}" class="form-group row row-no-gutters">
                            <label for="auth-token-ip-${auth_token_ip_count}" class="col-sm-3 col-form-label">IP Address ${auth_token_ip_count}</label>
                            <div class="col-sm-6">
                                <input id="auth-token-ip-${auth_token_ip_count}" type="text" name="auth-token-ip-${auth_token_ip_count}" class="form-control">
                            </div>
                            <div class="col-sm-3">
                                <button type="button" id="auth-token-ip-${auth_token_ip_count}-remove-button" class="btn btn-danger auth-token-ip-remove-button">Remove</button>
                            </div>
                        </div>
                    `);
                });

                $('.auth-token-ip-remove-button').click(function() {
                    let ip_identifier = this.id.replace('auth-token-ip-', '').replace('-remove-button', '');
                    let form_group = $(`#auth-token-ip-div-${ip_identifier}`);
                    form_group.remove();
                });
            });
        </script>
    </body>
</html>